// Communication.h
 
// Intefejs pre komunikaciu so serverom

#ifndef COMMUNICATION_H
#define COMMUNICATION_H

#include "Common/Interfaces/Interface.h"

// Intefejs pre komunikaciu so serverom
class CommunicationInterface : public Interface
{
public:
	// Konstruktor
	CommunicationInterface()
		: Interface("Interfejs komunikacie", "v0.04")
	{
	
	}
	// Destruktor
	virtual ~CommunicationInterface()
	{
	
	}
	
	// METODY

	// Nastavenie servera
	virtual int SetServer(const char* addr, unsigned port) = 0;
	// Pripojenie sa k serveru
	virtual int Connect(const char* msg = NULL) = 0;
	// Zaslanie spravy
	virtual int SendMsg(const char* msg) = 0;
	// Obdrzanie spravy
	virtual int ReceiveMsg() = 0;
	// Odpojenie od servera
	virtual int Disconnect(const char* msg = NULL) = 0;

};

#endif // COMMUNICATION_H
