// Interface.h

// Koren vsetkych interfejsov

#ifndef INTERFACE_H
#define INTERFACE_H

#include "Common/Protocol/CharString.h"


// Kazdy interfejs v systeme je dedeny z tejto triedy
class Interface
{
	// Nazov interfejsu
	CharString m_strName;
	// Verzia intefejsu
	CharString m_strVersion;

public:
	// Konstruktory
	Interface(const char* pStrName, const char* pStrVer)
		: m_strName(pStrName), m_strVersion(pStrVer) 
	{
	
	}
	Interface(const CharString& strName, const CharString& strVer)
		: m_strName(strName), m_strVersion(strVer)
	{
	
	}
	virtual ~Interface()
	{
	
	}

	// Metody
	CharString GetInterfaceName() const
	{
		return m_strName;
	}

	CharString GetInterfaceVersion() const
	{
		return m_strVersion;
	}
};

#endif // INTERFACE_H
