#include "KickOffBehaviour.h"
#include "../../CommonFunctions.h"
//#define G_TXTN	TXTN

extern CEvaluatingPlayerList* ePlayerList;

/*
 *	Vykopvanie lopty
 *  Funkcia realizujca sprvanie:  LPT_KickOff()
 *	Pomocn funkcie: int NumberOfEnemiesAround(const Point p,float dist=5.0f)  premiestnena do DataStorage
 *  vykopavanie lopty (po zachyteni brankarom, alebo netrafeni sa supera na branu)
 */
void KickOffBehaviour::Behave()
{
	G_TXTN("  KickOff, mode: %d; ours: %d, theirs: %d",DATA_STORAGE.goalieKickOff,world->friends.GetSize(),world->enemies.GetSize());
	Point myPosition = world->me->pos;
	static Point kickoffPosition;
	static int scanning;
	switch(DATA_STORAGE.goalieKickOff)
	{
	case GOALIE_GOFORBALL:
		if(world->state->GetPlayMode() == PM_GoalKick_Our)
		{
			if((world->ball->pos-world->me->pos).GetLength()>world->params->server->kickable_margin * 0.6f)
			{
				//ak som od daleko od lopty, idem pre nu
				Point p = world->ball->pos;
				p.SetX(p.GetX()-0.4f);	//postavim sa kusok za loptu
				GetRunToPositionBehaviour()->Behave(p, false, false, 0.);
				break;
			}
		}
		//som uz pri nej dostatocne blizko, alebo som bol v mode, ze som ju chytil; break tu nemusi byt
		DATA_STORAGE.goalieKickOff = GOALIE_CAUGHT;
		scanning = world->state->GetSimTime();
	case GOALIE_CAUGHT:
		//otoc sa na stred a pozoruj
		GetTurnToBehaviour()->Behave(Point(0, 0));
		//AlignNeck();
		GetAlignNeckBehaviour()->Behave();
		commandGenerator->ChangeView(WIDE_VIEW);
		DATA_STORAGE.SetNextSynchMode(Synch_WaitForVI);
		//ak si oddychnuty, prepni mod
		if(world->me->GetStamina() > world->params->server->stamina_max * 0.9f)
			DATA_STORAGE.goalieKickOff = GOALIE_SCAN;
		break;
	case GOALIE_SCAN:
		//otoc sa na stred a pozoruj
		GetTurnToBehaviour()->Behave(Point(0, 0));
		GetAlignNeckBehaviour()->Behave();
		commandGenerator->ChangeView(WIDE_VIEW);
		DATA_STORAGE.SetNextSynchMode(Synch_WaitForVI);
		//ak uz sme skenovali akurat dost (viac ako 30 cyklov)
		if((world->state->GetSimTime() - scanning) >= 30)
		{
			if(world->state->GetPlayMode() == PM_FreeKick_Our)
			{
				Point bod1=Point(-39.,-8.);
				Point bod2=Point(-39.,8.);
				kickoffPosition = DATA_STORAGE.NumberOfEnemiesAround(bod1,15.) < DATA_STORAGE.NumberOfEnemiesAround(bod2,15.) ? bod1 : bod2;
//				kickoffPosition=Point(-45.f,myPosition.GetY()<0. ? -6.f : 6.f);
//				kickoffPosition=Point(-39.f,myPosition.GetY()<0. ? -8.f : 8.f);
				GetMoveBehaviour()->Behave(kickoffPosition);
				world->me->pos = kickoffPosition;
				world->me->vel = Vector();
				world->ball->pos = world->me->pos;
				world->ball->vel = Vector();
			}
			DATA_STORAGE.goalieKickOff = GOALIE_KICK;
		}
		break;
	case GOALIE_KICK:
		//TODO: skusit, z ktorych pozicii sa da presunut
		//FIITBA_START
		if(world->state->GetPlayMode() == PM_FreeKick_Our)
		{
			Point kickPos(-22, myPosition.GetY() < 0. ? -20.f : 20.f);
			GetKickBehaviour()->Behave(kickPos);
			DATA_STORAGE.goalieKickOff = GOALIE_GOHOME;
			return;
		}
		double fTmpX, fTmpY;
		if(world->state->GetPlayMode() == PM_GoalKick_Our)
			kickoffPosition = myPosition;
		if(ePlayerList->CalculateNormalPassPosition(kickoffPosition.GetX(),
			kickoffPosition.GetY(), fTmpX, fTmpY))
		{
			Point passPosition((float)fTmpX, (float)fTmpY);
			
			if((world->me->pos.GetX() + 10) < fTmpX)
			{
				G_TXTN("PASS1");
				GetPassBallToBehaviour()->Behave(passPosition, 100);
				DATA_STORAGE.goalieKickOff = GOALIE_GOHOME;
				return;
			}
		}
		
		// Predkopnem si loptu
		double lfGoalKickX;
		lfGoalKickX = kickoffPosition.GetX(); 
		double lfGoalKickY;
		lfGoalKickY = kickoffPosition.GetY(); 
		
		if(ePlayerList->CalculateOptimalDribblePointAux(lfGoalKickX, lfGoalKickY, 25.0))
		{
			G_TXTN("PASS2");
			GetPassBallToBehaviour()->Behave(Point((float)lfGoalKickX, (float)lfGoalKickY), 100);
		}
		else 
		{
			G_TXTN("PASS3");
			GetPassToStrategicPositionBehaviour()->Behave();
		}
		
		DATA_STORAGE.goalieKickOff = GOALIE_GOHOME;
		//FIITBA_END
		break;
	case GOALIE_GOHOME:
		//obranny mod
		GetDefenseLineBehaviour()->Behave();
		break;
	}
}
