#ifndef KICKOFF_BEHAVIOUR_H_
#define KICKOFF_BEHAVIOUR_H_

#include "../../ModuleInterface.h"
#include "../PassBallToBehaviour.h"
#include "../PassToStrategicPositionBehaviour.h"
#include "../KickBehaviour.h"
#include "../RunToPositionBehaviour.h"
#include "../TurnToBehaviour.h"
#include "../AlignNeckBehaviour.h"
#include "../MoveBehaviour.h"
#include "DefenseLineBehaviour.h"
#include "../../DataStorage.h"


/*
 *	Vykopvanie lopty
 *  Funkcia realizujca sprvanie:  LPT_KickOff()
 *	Pomocn funkcie: int NumberOfEnemiesAround(const Point p,float dist=5.0f)  premiestnena do DataStorage
 *  vykopavanie lopty (po zachyteni brankarom, alebo netrafeni sa supera na branu)
 */
class KickOffBehaviour : public ModuleInterface
{
	//pouzite moduly spravania
	USE_MODULE(PassBallToBehaviour)
	USE_MODULE(PassToStrategicPositionBehaviour)
	USE_MODULE(KickBehaviour)
	USE_MODULE(RunToPositionBehaviour)
	USE_MODULE(TurnToBehaviour)
	USE_MODULE(AlignNeckBehaviour)
	USE_MODULE(MoveBehaviour)
	USE_MODULE(DefenseLineBehaviour)
	


public:
	virtual void Behave();
};

#endif /* KICKOFF_BEHAVIOUR_H_ */
