#include "UnblockMyselfBehaviour.h"
#include "../CommonFunctions.h"

/*
 *	
 *
 *	Presunutie sa od blokujceho spera, otoenie sa smerom odkia ide lopta.
 */ 
bool UnblockMyselfBehaviour::Behave(Vector* shift)
{
	//	UBLK_DBGN("%i: Trying Unblock", world->state->GetSimTime());

		// Presun sa kusok od blokujuceho supera
	if(!world->ball->IsValid()) 
	{
//			UBLK_DBGN("%i: ball invalid", world->state->GetSimTime());
		return false;
	}
	
	// Je lopta dostatocne daleko?
	Vector dBall = world->ball->pos - world->me->pos;
	if(dBall.GetLength() < 5.f) 
	{ 
		//UBLK_DBGN("%i: ball too near %3.2f", world->state->GetSimTime(), dBall.GetLength());
		return false;
	}

	// Som otoceny tym istym smerom ako lopta?
	Angle delta = (world->me->GetAbsDir() - dBall.GetAngle()).Abs();
	
	if(delta > DegAngle(25)) 
	{
	//	UBLK_DBGN("%i: bad absdir %3.2f", world->state->GetSimTime(), delta.GetDeg());
		return false;
	}

	// Kde by som sa mal presunut?
	*shift = RectVector(0, 0);
	
	int posCnt = 0;
	int negCnt = 0;

	int i;
	for(i = 0; i < world->enemies.GetSize(); i++)
	{
		Vector dEnemy = world->enemies[i].pos - world->me->pos;
		Angle alpha = (dEnemy.GetAngle() - dBall.GetAngle()).Abs();

		float eLen = (dBall - dEnemy).GetLength();

	    if(eLen < dBall.GetLength() && dEnemy.GetLength() < 2.f && alpha < DegAngle(60))
		{
/*			if(dEnemy.GetAngle() > DegAngle(0)) posCnt++;
			else if(dEnemy.GetAngle() < DegAngle(0)) negCnt++;
			else { posCnt++; negCnt++; }*/

			Vector tmp = PolarVector(5.f/*2.f * dEnemy.GetLength()*/, world->me->GetAbsDir());
			if(tmp.GetLength() > shift->GetLength())
				*shift = tmp;
		
		//	UBLK_DBGN("%i: Blocked by %i angle %3.2f", world->state->GetSimTime(), world->enemies[i].GetUniform(), alpha.GetDeg());
		}
	}

	if(shift->GetLength() == 0)
		return false;

	if(shift->GetLength() > 5.f)
		shift->SetLength(5.f);
	
	return true;
		
}
