// Movable.h
 
// Predstavuje vseobecny pohybujuci sa objekt sveta

#ifndef MOVABLE_H
#define MOVABLE_H

#include "Player/World/WorldObject.h"
#include "Common/World/Point.h"
#include "Common/World/Vector.h"

// Vseobecny pohybujuci sa objekt sveta
class Movable : public WorldObject
{
protected:
	int age;	// Vek informacie pohybujuceho sa objektu

public:
	
	Point pos;	// Bodova pozicia pohybujuceho sa objektu
	Vector vel;	// Smer pohybujuceho sa objektu

	// Konstuktor
	Movable(World* w);
	// Kopirovaci konstruktor
	Movable(const Movable&);
	
	// Destruktor
	virtual ~Movable()
	{
	
	}
	
	// Operator priradenia
	virtual Movable& operator =(const Movable&);
	
	// Metody 
	virtual int GetAge() const
	{
		return age;
	}
	virtual void SetAge(int a)
	{
		age = a;
	}

};

#endif // MOVABLE_H
